#pragma once


LPCWSTR GetCmdErrorMessage(DWORD Err);
LPCWSTR GetDayOfWeekText(UINT DayOfWeek);

int CompareSystemTime(const SYSTEMTIME &Time1,const SYSTEMTIME &Time2);
void GetEndTime(const SYSTEMTIME &StartTime,DWORD Duration,SYSTEMTIME *pEndTime);

void EnableDlgItem(HWND hDlg,int ID,bool fEnable);
void EnableDlgItems(HWND hDlg,int FirstID,int LastID,bool fEnable);
void SetComboBoxList(HWND hDlg,int ID,LPCTSTR const *pList,int Length);
int GetDlgItemString(HWND hDlg,int ID,wstring *pString);
int GetComboBoxString(HWND hDlg,int ID,int Index,wstring *pString);
int SetListBoxHorzExtent(HWND hDlg,int ID);

bool FileOpenDialog(HWND hwndOwner,wstring *pFileName,LPCWSTR pszTitle,
					LPCWSTR pFilter,LPCWSTR pszDefaultExtension=NULL);
bool BrowseFolderDialog(HWND hwndOwner,wstring *pFolder,LPCWSTR pszTitle);

class CCriticalLock
{
	CRITICAL_SECTION m_CriticalSection;
public:
	CCriticalLock() { ::InitializeCriticalSection(&m_CriticalSection); }
	~CCriticalLock() { ::DeleteCriticalSection(&m_CriticalSection); }
	void Lock() { ::EnterCriticalSection(&m_CriticalSection); }
	void Unlock() { ::LeaveCriticalSection(&m_CriticalSection); }
};

class CBlockLock
{
	CCriticalLock &m_Lock;
public:
	CBlockLock(CCriticalLock &Lock) : m_Lock(Lock) { m_Lock.Lock(); }
	~CBlockLock() { m_Lock.Unlock(); }
};
